#PHYSICS ENGINE FOR PLANE
#velocities and angles have 3 decimal places

#PLAYER CONTROL

#calculate % throttle
scoreboard players operation @s sim.pcntThrottle = @s sim.throttle
scoreboard players operation @s sim.pcntThrottle *= 100 sim.constant
scoreboard players operation @s sim.pcntThrottle /= maxThrottle sim.constant

#yaw position and thrust due to throttle
scoreboard players operation @s sim.yawpos %= 360 sim.constant
execute if score @s sim.yawpos > 180 sim.constant run scoreboard players operation @s sim.yawpos -= 360 sim.constant
execute if score @s sim.yawpos > yawMax sim.constant run scoreboard players operation @s sim.yawpos = yawMax sim.constant
execute if score @s sim.yawpos < yawMin sim.constant run scoreboard players operation @s sim.yawpos = yawMin sim.constant

scoreboard players operation @s sim.thrust = @s sim.throttle
scoreboard players operation @s sim.thrust /= throttleMult sim.constant

#TEST IF ON GROUND
#play landing screech before updating OnGround variable
execute as @s[nbt={OnGround:1b},scores={sim.ground=0,sim.xvel=400..}] at @s run playsound minecraft:entity.player.breath player @a ~ ~ ~ 0.2 1


#update OnGround variable
execute store result score @s sim.ground run data get entity @s OnGround 1
execute if score @s sim.ground matches 1 run scoreboard players set @s sim.yvel 0

#IMPORTANT VARIABLES

scoreboard players operation temp sim.Global = @s sim.xvel
scoreboard players operation temp2 sim.Global = @s sim.yvel

scoreboard players operation temp sim.Global *= @s sim.xvel
scoreboard players operation temp2 sim.Global *= @s sim.yvel

scoreboard players operation @s sim.velsq = temp sim.Global
scoreboard players operation @s sim.velsq += temp2 sim.Global

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig2,limit=1] Pos[0] double 0.001 run scoreboard players get @s sim.yvel
execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig2,limit=1] Pos[2] double 0.001 run scoreboard players get @s sim.xvel
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0 facing entity @e[tag=trig2,type=area_effect_cloud,limit=1]
execute store result score @s sim.airdir run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] -1000

scoreboard players operation @s sim.aoa = @s sim.angle
scoreboard players operation @s sim.aoa += aoi sim.constant
scoreboard players operation @s sim.aoa -= @s sim.airdir
scoreboard players operation @s sim.aoa %= 180 sim.constant

#FRICTION

execute if score @s sim.ground matches 1 run function dt_flight_sim:friction

#DRAG

scoreboard players operation @s sim.drag = @s sim.velsq
scoreboard players operation @s sim.drag *= drag sim.constant
execute at @s unless block ~ ~0.5 ~ #dt_flight_sim:fly_thru run scoreboard players operation @s sim.drag *= liquiddrag sim.constant
scoreboard players operation @s sim.drag /= 100000 sim.constant

scoreboard players operation temp sim.Global = @s sim.xvel
scoreboard players operation temp2 sim.Global = @s sim.yvel

scoreboard players operation temp sim.Global *= @s sim.drag
scoreboard players operation temp2 sim.Global *= @s sim.drag
scoreboard players operation temp sim.Global /= 1000 sim.constant
scoreboard players operation temp2 sim.Global /= 1000 sim.constant

scoreboard players operation @s sim.xvel -= temp sim.Global
scoreboard players operation @s sim.yvel -= temp2 sim.Global

#angular drag
scoreboard players operation temp sim.Global = @s sim.anglevel
scoreboard players operation temp2 sim.Global = @s sim.hanglevel

scoreboard players operation temp sim.Global *= angveldrag sim.constant
scoreboard players operation temp2 sim.Global *= angveldrag sim.constant

scoreboard players operation temp sim.Global /= 1000 sim.constant
scoreboard players operation temp2 sim.Global /= 1000 sim.constant

execute if score @s sim.anglevel matches -10..10 run scoreboard players set @s sim.anglevel 0
execute if score @s sim.hanglevel matches -10..10 run scoreboard players set @s sim.hanglevel 0

scoreboard players operation @s sim.anglevel -= temp sim.Global
scoreboard players operation @s sim.hanglevel -= temp2 sim.Global

#torque due to drag
scoreboard players operation temp sim.Global = @s sim.airdir
scoreboard players operation temp sim.Global -= @s sim.angle

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.001 run scoreboard players get temp sim.Global
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score temp sim.Global run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[0] 1000

scoreboard players operation temp sim.Global *= @s sim.drag
scoreboard players operation temp sim.Global /= 1000 sim.constant

scoreboard players operation temp sim.Global *= dragOffset sim.constant

scoreboard players operation @s sim.anglevel += temp sim.Global

#LIFT

#regular lift
scoreboard players operation @s sim.lift = @s sim.aoa
execute if score @s sim.aoa matches 165000..180000 run scoreboard players operation @s sim.lift -= 180 sim.constant

#stal (beyond 15 deg aoa)
execute if score @s sim.aoa matches 15001..164999 run scoreboard players operation @s sim.lift -= 90 sim.constant
execute if score @s sim.aoa matches 15001..164999 run scoreboard players operation @s sim.lift /= stallFactor sim.constant

scoreboard players operation @s sim.velsq /= 1000 sim.constant
scoreboard players operation @s sim.lift *= @s sim.velsq
scoreboard players operation @s sim.lift /= 10000 sim.constant

scoreboard players operation temp sim.Global = @s sim.airdir
scoreboard players operation temp sim.Global += 90 sim.constant

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.001 run scoreboard players get temp sim.Global
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score sin2 sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[0] 1000
execute store result score cos2 sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[2] 1000

scoreboard players operation cos2 sim.trig *= @s sim.lift
scoreboard players operation sin2 sim.trig *= @s sim.lift

scoreboard players operation cos2 sim.trig /= 10000 sim.constant
scoreboard players operation sin2 sim.trig /= 10000 sim.constant

#CONTROL

#control surface clamp (for pitch)
execute if score @s sim.cspos > csposMax sim.constant run scoreboard players operation @s sim.cspos = csposMax sim.constant
execute if score @s sim.cspos < csposMin sim.constant run scoreboard players operation @s sim.cspos = csposMin sim.constant

#pitch
scoreboard players operation temp sim.Global = @s sim.angle
scoreboard players operation temp sim.Global -= @s sim.airdir

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.001 run scoreboard players get temp sim.Global
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score temp sim.Global run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[2] 1000

scoreboard players operation temp sim.Global *= @s sim.velsq
scoreboard players operation temp sim.Global /= 1000 sim.constant
scoreboard players operation temp sim.Global *= @s sim.cspos
scoreboard players operation temp sim.Global *= surfaceControl sim.constant
scoreboard players operation temp sim.Global /= 100000 sim.constant

scoreboard players operation @s sim.anglevel += temp sim.Global

#yaw

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.0005 run scoreboard players get @s sim.yawpos
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score sin sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[0] 1000
execute store result score cos sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[2] 1000

#approximate value for sqrt(velsq). accurate for values between 40 and 600
scoreboard players operation temp sim.Global = @s sim.velsq
scoreboard players operation temp sim.Global += 220 sim.constant

execute if score @s sim.lift matches ..0 run scoreboard players operation @s sim.lift *= -1 sim.constant
scoreboard players operation sin sim.trig *= surfaceControl sim.constant
scoreboard players operation sin sim.trig *= @s sim.lift
scoreboard players operation sin sim.trig /= 1000 sim.constant
scoreboard players operation sin sim.trig *= turnForce sim.constant
scoreboard players operation sin sim.trig /= temp sim.Global

scoreboard players operation @s sim.hanglevel = sin sim.trig

#some post processing for LIFT. we first needed bank angle
scoreboard players operation cos2 sim.trig *= cos sim.trig
scoreboard players operation sin2 sim.trig *= cos sim.trig

scoreboard players operation cos2 sim.trig /= 1000 sim.constant
scoreboard players operation sin2 sim.trig /= 1000 sim.constant

scoreboard players operation @s sim.xvel += cos2 sim.trig
scoreboard players operation @s sim.yvel += sin2 sim.trig

#ground physics (tail wheel and Vrot)
execute if score @s sim.ground matches 1 run function dt_flight_sim:ground_physics

#TEST IF DESTROYED
#execute at @s run function dt_flight_sim:destroy
execute unless score @s sim.broken matches 1.. at @s if block ~ ~1 ~ minecraft:water run function dt_flight_sim:destroy
execute unless score @s sim.broken matches 1.. at @s unless entity @s[predicate=dt_flight_sim:in_overworld] run function dt_flight_sim:destroy
execute unless score @s sim.broken matches 1.. at @s unless block ^ ^0.5 ^0.5 #dt_flight_sim:fly_thru if score @s sim.velsq >= destroySpeed sim.constant run function dt_flight_sim:destroy

#THRUST

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.001 run scoreboard players get @s sim.angle
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score sin sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[0] 1000
execute store result score cos sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[2] 1000

#engine working check
execute if score @s sim.fuel matches ..0 run scoreboard players set @s sim.thrust 0
execute if score @s sim.broken matches 1.. run scoreboard players set @s sim.thrust 0

scoreboard players operation sin sim.trig *= @s sim.thrust
scoreboard players operation cos sim.trig *= @s sim.thrust
scoreboard players operation sin sim.trig /= 1000 sim.constant
scoreboard players operation cos sim.trig /= 1000 sim.constant

scoreboard players operation @s sim.xvel += cos sim.trig
scoreboard players operation @s sim.yvel += sin sim.trig

#GRAVITY

scoreboard players operation @s sim.yvel += gravity sim.constant

#WATER SKIING
execute at @s if block ~ ~0.2 ~ minecraft:water run function dt_flight_sim:water_ski

#APPLY VELOCITIES

execute store result entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Rotation[0] float -0.001 run scoreboard players get @s sim.heading
tp @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] 0.0 0 0.0
execute as @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] at @s run tp ^ ^ ^1
execute store result score sin sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[0] 1000
execute store result score cos sim.trig run data get entity @e[type=minecraft:area_effect_cloud,tag=trig,limit=1] Pos[2] 1000

scoreboard players operation sin sim.trig *= @s sim.xvel
scoreboard players operation cos sim.trig *= @s sim.xvel

scoreboard players operation @s sim.angle += @s sim.anglevel
scoreboard players operation @s sim.heading += @s sim.hanglevel

execute store result entity @s Motion[0] double 0.000001 run scoreboard players get sin sim.trig
execute store result entity @s Motion[2] double 0.000001 run scoreboard players get cos sim.trig

execute store result entity @s Motion[1] double 0.001 run scoreboard players get @s sim.yvel

#UPDATE PLANE ROTATIONS

#pitch & yaw
execute store result entity @s Rotation[0] float -0.001 run scoreboard players get @s sim.heading
execute store result entity @s Rotation[1] float -0.001 run scoreboard players get @s sim.angle

execute at @s store result entity @e[tag=body,sort=nearest,limit=1,distance=..2] Pose.Head[0] float -0.001 run scoreboard players get @s sim.angle

#roll
scoreboard players operation temp sim.Global = @s sim.yawpos
execute if score @s sim.ground matches 1 run scoreboard players set temp sim.Global 0
scoreboard players operation temp sim.Global -= @s sim.roll
scoreboard players operation temp sim.Global /= smoothRoll sim.constant
scoreboard players operation @s sim.roll += temp sim.Global

execute at @s store result entity @e[tag=driver,sort=nearest,limit=1,distance=..2] Rotation[0] float -0.001 run scoreboard players get @s sim.heading
execute at @s store result entity @e[tag=body,sort=nearest,limit=1,distance=..2] Rotation[0] float -0.001 run scoreboard players get @s sim.heading
execute at @s store result entity @e[tag=body,sort=nearest,limit=1,distance=..2] Pose.Head[2] float 0.0005 run scoreboard players get @s sim.roll